package ru.landgrafhomyak.db.skeleton1.api

public enum class LifeTime {
	REGULAR {
		override fun isAlwaysAvailableAt(parent: LifeTime): Boolean = true
	},

	TRANSACTION_SCOPE {
		override fun isAlwaysAvailableAt(scope: LifeTime): Boolean = scope === this
	},

	CONNECTION_SCOPE {
		override fun isAlwaysAvailableAt(scope: LifeTime): Boolean = scope === LifeTime.TRANSACTION_SCOPE || scope === this
	},

	MODULE_UPGRADE_SCOPE {
		override fun isAlwaysAvailableAt(scope: LifeTime): Boolean = scope === this
	};

	public abstract fun isAlwaysAvailableAt(scope: LifeTime): Boolean
}