package ru.landgrafhomyak.db.skeleton1.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LifeTime
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectClass
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.table.Table
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow


public interface ModuleConstructorScope<UE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("rootNs")
	public val rootNameNode: NameNode<UE>

	public fun <tUE : Any> table_create(
		lifeTime: LifeTime = LifeTime.REGULAR,
		location: NameNode<UE>,
		initializer: Table.Constructor<tUE>
	): Table<tUE, UE>

	public fun object_create(
		lifeTime: LifeTime = LifeTime.REGULAR,
		location: NameNode<UE>,
		metadata: ObjectClass.ImplementationsProvider
	): ModuleScopedObject<UE>

	public fun <smUE : Any> submodule_substitute(location: NameNode<UE>, template: Module.Template<smUE>): Module<smUE>

	public fun nameNode(parent: NameNode<UE>, name: String): NameNode<UE>

	public fun addStatement(statement: _Statement.Void2Void<*>)
	public fun addStatement(provider: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addStatement(statement: _Statement.Params2Void<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatement(provider: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>
}