package ru.landgrafhomyak.db.skeleton1.api.module

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow
import ru.landgrafhomyak.db.skeleton1.api.table.Table


public interface ModuleUpgradeScope<nUE : Any, oUE : Any> : ModuleConstructorScope<nUE> {
	// Table -------------------------------------------------------------------
	public fun <tUE : Any> table_keep(table: Table<tUE, oUE>): Table<tUE, nUE>
	public fun <tUE : Any> table_keepAndMove(table: Table<tUE, oUE>, newLocation: NameNode<nUE>): Table<tUE, nUE>

	public fun <tnUE : Any, toUE : Any> table_upgrade(table: Table<toUE, oUE>, upgrade: Table.Upgrade<tnUE, toUE>): Table<tnUE, nUE>
	public fun <tnUE : Any, toUE : Any> table_upgradeAndMove(table: Table<toUE, oUE>, newLocation: NameNode<nUE>, upgrade: Table.Upgrade<tnUE, toUE>): Table<tnUE, nUE>

	public fun table_delete(table: Table<*, oUE>)
	public fun <tUE : Any> table_deleteAfterModuleUpgrade(table: Table<tUE, oUE>): Table<tUE, nUE>

	public fun table_export(table: Table<*, oUE>)

	public fun <tUE : Any> table_import(table: Table<tUE, *>, location: NameNode<nUE>): Table<tUE, nUE>
	public fun <tnUE : Any, toUE : Any> table_importAndUpgrade(table: Table<toUE, *>, location: NameNode<nUE>, upgrade: Table.Upgrade<tnUE, toUE>): Table<tnUE, nUE>

	// Object ------------------------------------------------------------------

	public fun object_keep(obj: ModuleScopedObject<oUE>): ModuleScopedObject<nUE>
	public fun object_keepAndMove(obj: ModuleScopedObject<oUE>, newLocation: NameNode<nUE>): ModuleScopedObject<nUE>

	public fun object_delete(obj: ModuleScopedObject<oUE>)
	public fun object_deleteAfterModuleUpgrade(obj: ModuleScopedObject<oUE>): ModuleScopedObject<nUE>

	public fun object_export(obj: ModuleScopedObject<oUE>)
	public fun object_import(obj: ModuleScopedObject<*>, location: NameNode<nUE>): ModuleScopedObject<nUE>

	// Module ------------------------------------------------------------------

	public fun <smUE : Any> submodule_keep(submodule: Module<smUE>): Module<smUE>
	public fun <smUE : Any> submodule_keepAndMove(submodule: Module<smUE>, newLocation: NameNode<nUE>): Module<smUE>

	public fun <smUE : Any> submodule_upgrade(submodule: Module<*>, template: Module.Template<smUE>): Module<smUE>
	public fun <smUE : Any> submodule_upgradeAndMove(submodule: Module<*>, newLocation: NameNode<nUE>, template: Module.Template<smUE>): Module<smUE>

	public fun submodule_delete(submodule: Module<*>)
	public fun <smUE : Any> submodule_deleteAfterModuleUpgrade(submodule: Module<smUE>): Module<smUE>

	public fun submodule_export(submodule: Module<*>)

	public fun <smUE : Any> submodule_import(module: Module<smUE>, location: NameNode<nUE>): Module<smUE>

	public fun <smUE : Any> submodule_importAndUpgrade(module: Module<smUE>, location: NameNode<nUE>, template: Module.Template<smUE>): Module<smUE>

	// Statements --------------------------------------------------------------

	public fun addStatementAfterUpgrade(statement: _Statement.Void2Void<*>)
	public fun addStatementAfterUpgrade(provider: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addStatementAfterUpgrade(statement: _Statement.Params2Void<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatementAfterUpgrade(provider: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>
}