package ru.landgrafhomyak.db.skeleton1.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.DatabaseType
import ru.landgrafhomyak.db.skeleton1.api.LifeTime

public interface Column<RT, tUE : Any> {
	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("name")
	public val name: String

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("type")
	public val type: DatabaseType.ImplementationsProvider<RT>

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getTable")
	public val table: Table<tUE, *>

	@ReflectionApi
	public val lifeTime: LifeTime

	public val unwrappedColumn: Column<RT, tUE>
}