package ru.landgrafhomyak.db.skeleton1.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LifeTime
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.module.Module
import ru.landgrafhomyak.db.skeleton1.api.module.ModuleScopedObject

public interface Table<UE : Any, mUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: UE

	public val unwrappedTable: Table<UE, mUE>

	@ReflectionApi
	public val pathFromParentModuleRoot: List<String>

	@ReflectionApi
	public val parentModule: Module<mUE>

	@ReflectionApi
	public val lifeTime: LifeTime

	@ReflectionApi
	public fun memberColumns(scope: LifeTime): Collection<Column<*, UE>>

	@ReflectionApi
	public fun memberObjects(scope: LifeTime): Collection<TableScopedObject<UE>>

	public interface Constructor<tUE : Any> {
		public fun createTable(context: TableConstructorScope<tUE>): tUE
	}

	public interface Upgrade<tnUE : Any, toUE : Any> {
		public fun upgradeTable(oldTable: toUE, context: TableUpgradeScope<tnUE, toUE>): tnUE
	}
}